<template>
  <single-pane ref="singlePane">
    <div class="h-100">
      <ob-table
        :items="items"
        :columns="columns"
        :functionalPanel="true"
        @select="$refs.popup.open()"
        :tableLayoutFixed="false"
      >
        <template v-slot:comment="{ data }">
          <i class="icon edit"></i>
        </template>
      </ob-table>
        
      <ObModal 
        title="Настройка категорий"
        title-second="Редактирование"
        ref="popup"
      >

        <edit-popup
          :data-source="durationOptions"
          @changed="changeHandler"
          @close="$refs.popup.close()"
        />
      </ObModal>
    </div>
  </single-pane>
</template>

<script>
import api from "@/api";
import moment from 'moment';
import SinglePane from "common-components/src/obComponents/obSinglePanels";
import ObTable from "common-components/src/obComponents/obTable";
import ObModal from "common-components/src/obComponents/obModal";
import EditPopup from "./modal/edit";

export default {
  components: {
    ObTable,
    EditPopup,
    ObModal,
    SinglePane
  },
  computed: {

  },
  data() {
    return {
      api,
      durationOptions: {},
      columns: [
        {
          title: 'Продолжительность рейса',
          key: "title",
          exactWidth: "200px"
        },
        {
          title: 'Часы',
          key: 'duration',
          exactWidth: "65%"
        },
        {
          title: 'Дата',
          key: 'date',
          // exactWidth: "190px",
          html({ date }) {
            return `<div class="field-datetime">
              <div>${moment(date).locale('ru').format('L')}</div>
            </div>`
          }
        },
        {
          title: "",
          key: "comment",
          slotName: "comment",
          sortDisable: true,
          isToggleDisabled: true
        }
      ],
      items: [
        {
          title: "Длинный",
          duration: "> 24",
          date: "21.11.2018"
        },
        {
          title: "Средний",
          duration: "8 — 24",
          date: "21.11.2018"
        },
        {
          title: "Короткий",
          duration: "< 8",
          date: "21.11.2018"
        }
      ]
    };
  },
  created() {
    this.fetch();
  },
  methods: {
    async fetch() {
      try {
        const response = await api.tripDuration.getTripDurationOptions();
        this.items.forEach(item => item.date = response.updatedDate);

        for (let i in response) {
          if (response[i] === null) response[i] = 0;
        }

        this.items[0].duration = `> ${response.highMinDuration}`;
        this.items[1].duration = `${response.mediumMinDuration} — ${response.highMinDuration}`;
        this.items[2].duration = `< ${response.mediumMinDuration}`;

        this.durationOptions = response;
      } catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        })
      }
    },

    changeHandler(data) {
      let notificationId = new Date().getTime()+'save';
      this.$notification({type: 'system_notification_in_load', message: 'Сохранение', id: notificationId});
      const payload = { ...data, updatedDate: new Date() };
      api.tripDuration
        .putTripDurationOptions(payload)
        .then(() => {
          this.fetch();
          this.$notification({
            type: 'system_notification_success',
            message: 'Сохранено'
          })
        }).catch((e)=>{
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Не сохранено'
        })
      }).finally(()=>{
        this.$notification({event: 'close', id: notificationId})
      });
    }
  }
};
</script>

<style lang="scss" scoped>
  ::v-deep {
    .edit {
      opacity: 0;
    }

    tr:hover .edit {
      opacity: 1;
    }
  }
</style>